diff -aruN --binary 21/components/com_content/models/category.php 22/components/com_content/models/category.php
--- 21/components/com_content/models/category.php	2010-04-23 13:40:12.000000000 +0200
+++ 22/components/com_content/models/category.php	2010-11-03 16:00:56.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: category.php 15201 2010-03-05 09:15:01Z ian $
+ * @version		$Id: category.php 19340 2010-11-03 15:00:55Z ian $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -330,6 +330,13 @@
 
 			$query = $this->_buildQuery();
 			$Arows = $this->_getList($query, $limitstart, $limit);
+			
+			// Check for db errors
+			if ($this->_db->getErrorNum())
+			{
+				JError::raiseError(500, $this->_db->stderror());
+				return false;
+			}
 
 			// special handling required as Uncategorized content does not have a section / category id linkage
 			$i = $limitstart;
@@ -382,6 +389,15 @@
 		$itemid = JRequest::getInt('id', 0) . ':' . JRequest::getInt('Itemid', 0);
 		$filter_order  = $mainframe->getUserStateFromRequest('com_content.category.list.' . $itemid . '.filter_order', 'filter_order', '', 'cmd');
 		$filter_order_Dir = $mainframe->getUserStateFromRequest('com_content.category.list.' . $itemid . '.filter_order_Dir', 'filter_order_Dir', '', 'cmd');
+
+		if (!in_array($filter_order, array('a.title', 'author', 'a.hits', 'a.created', 'a.publish_up', 'a.publish_down', 'a.modified'))) {
+			$filter_order = '';
+		}
+
+		if (!in_array(strtoupper($filter_order_Dir), array('ASC', 'DESC'))) {
+			$filter_order_Dir = 'ASC';
+		}
+
 		$orderby = ' ORDER BY ';
 		if ($filter_order && $filter_order_Dir)
 		{
diff -aruN --binary 21/components/com_content/models/section.php 22/components/com_content/models/section.php
--- 21/components/com_content/models/section.php	2010-04-23 13:40:12.000000000 +0200
+++ 22/components/com_content/models/section.php	2010-11-03 19:12:02.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: section.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: section.php 19343 2010-11-03 18:12:02Z ian $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -341,6 +341,14 @@
 			$query = $this->_buildQuery();
 			$Arows = $this->_getList($query, $limitstart, $limit);
 
+			// Check for db errors
+			if ($this->_db->getErrorNum())
+			{
+				JError::raiseError(500, $this->_db->stderror());
+				return false;
+			}
+			
+
 			// special handling required as Uncategorized content does not have a section / category id linkage
 			$i = $limitstart;
 			$rows = array();
@@ -433,8 +441,18 @@
 		$filter_order		= JRequest::getCmd('filter_order');
 		$filter_order_Dir	= JRequest::getWord('filter_order_Dir');
 
+		if (!in_array($filter_order, array('a.id', 'a.title', 'a.alias', 'a.title_alias', 'a.introtext', 'a.fulltext', 'a.sectionid', 'a.state',
+			'a.catid', 'a.created', 'a.created_by', 'a.created_by_alias', 'a.modified', 'a.modified_by', 'a.checked_out', 'a.checked_out_time',
+			'a.hits', 'a.ordering', 'a.metakey', 'a.access'))) {
+			$filter_order = 'a.ordering';
+		}
+
+		if (!in_array(trim(strtoupper($filter_order_Dir)), array('ASC', 'DESC'))) {
+			$filter_order_Dir = 'ASC';
+		}
+
 		$orderby = ' ORDER BY ';
-		if ($filter_order && $filter_order_Dir) {
+		if ($filter_order) {
 			$orderby .= $filter_order .' '. $filter_order_Dir.', ';
 		}
 
diff -aruN --binary 21/components/com_weblinks/models/category.php 22/components/com_weblinks/models/category.php
--- 21/components/com_weblinks/models/category.php	2010-04-23 13:40:14.000000000 +0200
+++ 22/components/com_weblinks/models/category.php	2010-11-03 19:12:02.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: category.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: category.php 19343 2010-11-03 18:12:02Z ian $
  * @package		Joomla
  * @subpackage	Content
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -81,9 +81,20 @@
 		// In case limit has been changed, adjust limitstart accordingly
 		$this->setState('limitstart', ($this->getState('limit') != 0 ? (floor($this->getState('limitstart') / $this->getState('limit')) * $this->getState('limit')) : 0));
 
+		$filter_order = JRequest::getCmd('filter_order', 'ordering');
+		$filter_order_Dir = JRequest::getCmd('filter_order_Dir', 'ASC');
+
+		if (!in_array($filter_order, array('title', 'hits', 'ordering'))) {
+			$filter_order = 'ordering';
+		}
+
+		if (!in_array(strtoupper($filter_order_Dir), array('ASC', 'DESC', ''))) {
+			$filter_order_Dir = 'ASC';
+		}
+
 		// Get the filter request variables
-		$this->setState('filter_order', JRequest::getCmd('filter_order', 'ordering'));
-		$this->setState('filter_order_dir', JRequest::getCmd('filter_order_Dir', 'ASC'));
+		$this->setState('filter_order', $filter_order);
+		$this->setState('filter_order_dir', $filter_order_Dir);
 
 		$id = JRequest::getVar('id', 0, '', 'int');
 		$this->setId((int)$id);
diff -aruN --binary 21/CREDITS.php 22/CREDITS.php
--- 21/CREDITS.php	2010-07-18 05:15:44.000000000 +0200
+++ 22/CREDITS.php	2010-11-02 14:49:14.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: CREDITS.php 18151 2010-07-15 09:33:47Z dextercowley $
+ * @version		$Id: CREDITS.php 19327 2010-11-02 13:49:13Z infograf768 $
  * @package		Joomla
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
@@ -69,7 +69,6 @@
 Albanian (sp-AL) - Blendi Kraja
 Arabic Unitag (ar-AA) - Arabic Unitag Translation Team - Mahmood Alhaj Kassem
 Azeri (az-AZ) - Azeri Translation Team - Mahmud and Yusif
-Basque (eu-ES) - Basque Translation Team (Basque Language School of Santurtzi) - Abel Camacho, Pedro Lonbide
 Belarusian (be-BY) - Dennis Hermacki
 Bengali (bn-BD) – Kamal Sikder
 Bosnian (bs-BA) - Bosnian Translation Team - Admir Agic
@@ -90,7 +89,6 @@
 German (de-DE)/(de-CH)/(de-AT) - J!German - Jan Erik Zassenhaus, Karin Nikolaj, David Jakob, Antonio Cambule\
 Greek (el-GR) - Greek Joomla Community - Aris Ntatsis
 Gujarati (gu-IN) - Gujarati Translation Team
-Hebrew (he-IL) - Joomla!Hebrew - Mati (MtK) Kochen
 Hindi (India) (hi-IN) - Hindi (India) Translation Team - Sanjeev Naroliya, Ronak Bhagdev, Aminuddin Sheikh
 Hungarian (hu-HU) - Magyar Joomla! Felhasznalok Nemzetkozi Egyesulete - Jozsef Tamas Herczeg, Annamaria Ban
 Icelandic (is-IS) - Joomlis! Icelandic Joomla Community [joomlis.net] - Magnús Guðlaugsson
@@ -106,16 +104,16 @@
 Norwegian bokmål (nb-NO) - Joomla! i Norge - Jens-Christian Skibakk, Rune Rasmussen
 Pashto (Afghanistan) (ps-AF) - Pashto (Afghanistan) Translation Team - Daud Nigaresh
 Persian/Farsi (fa-IR) - Joomfa Team(Joomla Farsi) - M.Alavi nik, Hamid abolhasani,Amin bagheri,Sayyed Saeed farzad,Sayyed ahmad sayyedi,Vahid Hosein Khani,Omid pileh var
-Polish - Poland (pl-PL) - Polskie Centrum Joomla! - Michał Sobkowiak, Stefan Wajda
+Polish - Poland (pl-PL) - Polskie Centrum Joomla! - Stefan Wajda
 Portuguese Brazilian (pt-BR) - Joomla! Brasil - Fabricio Elias Costa (FaBMak)
 Portuguese (pt-PT) - Joomla! Portugal - Paulo Izidoro
 Romanian (ro-RO) - Romanian Joomla! Community - Cosmin Lebu
 Russian (ru-RU) - Russian Translation Team - Serge Litvinov
-Serbian (sr-RS) - Joomla! Serbia team - Marko Milenovic
-Serbian (sr-YU) - Joomla! Serbia team - Svetlana Zec, Marko Milenovic
+Serbian (sr-RS) - Joomla! Serbia team - Svetlana Zec
+Serbian (sr-YU) - Joomla! Serbia team - Svetlana ZecSvetlana Zec
 Sindhi (sd-PK) - Raheel H. Kaghzi, Shafiq-ur-rehman Khatri
 Sinhala (si-LK) - Rashan Anushka
-Slovak (sk-SK) - Slovak Translation Team - Karol Cejka, Viliam Kmec, Alexander Horvath, Marek Sabo
+Slovak (sk-SK) - Karol Cejka
 Slovenian (sl-SI) - Slovenian Translation Team - Borut Planinc
 Spanish (es-ES) - Joomla!'s Spanish Community Translation Team - Javier Galasse
 Swedish (sv-SE) - Swedish Translation Team (SvenskJoomla!) - Sune Hultman, Christer Gerhardsson
diff -aruN --binary 21/libraries/joomla/factory.php 22/libraries/joomla/factory.php
--- 21/libraries/joomla/factory.php	2010-04-23 13:40:18.000000000 +0200
+++ 22/libraries/joomla/factory.php	2010-10-21 04:06:40.000000000 +0200
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: factory.php 15184 2010-03-04 23:18:17Z ian $
+ * @version		$Id: factory.php 19176 2010-10-21 03:06:39Z ian $
  * @package		Joomla.Framework
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
@@ -563,6 +563,7 @@
 		$db =& JDatabase::getInstance( $options );
 
 		if ( JError::isError($db) ) {
+			header('HTTP/1.1 500 Internal Server Error');
 			jexit('Database Error: ' . $db->toString() );
 		}
 
diff -aruN --binary 21/libraries/joomla/filesystem/file.php 22/libraries/joomla/filesystem/file.php
--- 21/libraries/joomla/filesystem/file.php	2010-04-23 13:40:18.000000000 +0200
+++ 22/libraries/joomla/filesystem/file.php	2010-10-21 04:08:56.000000000 +0200
@@ -1,9 +1,9 @@
 <?php
 /**
- * @version		$Id: file.php 14401 2010-01-26 14:10:00Z louis $
+ * @version		$Id: file.php 19177 2010-10-21 03:08:56Z ian $
  * @package		Joomla.Framework
  * @subpackage	FileSystem
- * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
+ * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
  * Joomla! is free software. This version may have been modified pursuant
  * to the GNU General Public License, and as distributed it includes or
@@ -35,8 +35,14 @@
 	 * @since 1.5
 	 */
 	function getExt($file) {
-		$dot = strrpos($file, '.') + 1;
-		return substr($file, $dot);
+		$chunks = explode('.', $file);
+		$chunksCount = count($chunks) - 1;
+
+		if($chunksCount > 0) {
+			return $chunks[$chunksCount];
+		}
+		
+		return false;
 	}
 
 	/**
diff -aruN --binary 21/libraries/joomla/filter/filterinput.php 22/libraries/joomla/filter/filterinput.php
--- 21/libraries/joomla/filter/filterinput.php	2010-07-18 05:15:44.000000000 +0200
+++ 22/libraries/joomla/filter/filterinput.php	2010-11-03 15:52:38.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: filterinput.php 18162 2010-07-16 07:00:47Z ian $
+ * @version		$Id: filterinput.php 19339 2010-11-03 14:52:38Z ian $
  * @package		Joomla.Framework
  * @subpackage	Filter
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -175,9 +175,9 @@
 				$lang = &JFactory::getLanguage();
 				$result = $lang->transliterate($result);
 				$result = (string) preg_replace(
-					array('/\s+/','/[^A-Za-z0-9\-\_]/'), array('-',''), $result
+					array('/\s+/','/[^A-Za-z0-9\-\_ ]/'), array('-',''), $result
 				);
-				$result = strtolower(trim($result));
+				$result = trim($result);
 				break;
 
 
diff -aruN --binary 21/libraries/joomla/session/session.php 22/libraries/joomla/session/session.php
--- 21/libraries/joomla/session/session.php	2010-04-23 13:40:18.000000000 +0200
+++ 22/libraries/joomla/session/session.php	2010-11-03 15:51:56.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
-* @version		$Id: session.php 16385 2010-04-23 10:44:15Z ian $
+* @version		$Id: session.php 19338 2010-11-03 14:51:55Z ian $
 * @package		Joomla.Framework
 * @subpackage	Session
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
@@ -507,40 +507,7 @@
 			// @TODO :: generated error here
 			return false;
 		}
-
-		// save values
-		$values	= $_SESSION;
-
-		// keep session config
-		$trans	=	ini_get( 'session.use_trans_sid' );
-		if( $trans ) {
-			ini_set( 'session.use_trans_sid', 0 );
-		}
-		$cookie	=	session_get_cookie_params();
-
-		// create new session id
-		$id	=	$this->_createId( strlen( $this->getId() ) );
-
-		// first we grab the session data
-		$data = $this->_store->read($this->getId());
-
-		// kill session
-		session_destroy();
-
-		// re-register the session store after a session has been destroyed, to avoid PHP bug
-		$this->_store->register();
-
-		// restore config
-		ini_set( 'session.use_trans_sid', $trans );
-		session_set_cookie_params( $cookie['lifetime'], $cookie['path'], $cookie['domain'], $cookie['secure'] );
-
-		// restart session with new id
-		session_id( $id );
-		session_start();
-		$_SESSION = $values;
-
-		//now we put the session data back
-		$this->_store->write($id, $data);
+		session_regenerate_id();
 		return true;
 	}
 
diff -aruN --binary 21/libraries/joomla/version.php 22/libraries/joomla/version.php
--- 21/libraries/joomla/version.php	2010-10-08 07:39:10.000000000 +0200
+++ 22/libraries/joomla/version.php	2010-11-03 16:00:56.000000000 +0100
@@ -1,6 +1,6 @@
 <?php
 /**
- * @version		$Id: version.php 19058 2010-10-08 04:15:39Z dextercowley $
+ * @version		$Id: version.php 19340 2010-11-03 15:00:55Z ian $
  * @package	Joomla.Framework
  * @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
  * @license		GNU/GPL, see LICENSE.php
@@ -26,13 +26,13 @@
 	/** @var string Development Status */
 	var $DEV_STATUS = 'Stable';
 	/** @var int Sub Release Level */
-	var $DEV_LEVEL 	= '21';
+	var $DEV_LEVEL 	= '22';
 	/** @var int build Number */
 	var $BUILD	= '';
 	/** @var string Codename */
-	var $CODENAME 	= 'senu takaa ama wepulai';
+	var $CODENAME 	= 'senu takaa ama woi';
 	/** @var string Date */
-	var $RELDATE 	= '08-October-2010';
+	var $RELDATE 	= '04-November-2010';
 	/** @var string Time */
 	var $RELTIME 	= '18:00';
 	/** @var string Timezone */
